      SUBROUTINE DEVRESET(DEAD1,E_H_PRES1,E_HB1,AQUABREED1,BREEDING1,
     & CONTDEP1,STAGE1,AQUASTAGE1,RESET1,COMPLETE1,WAITING1
     &,HOUR1,STAGES1,COMPLETION1)

C     NICHEMAPR: SOFTWARE FOR BIOPHYSICAL MECHANISTIC NICHE MODELLING

C     COPYRIGHT (C) 2018 MICHAEL R. KEARNEY AND WARREN P. PORTER

C     THIS PROGRAM IS FREE SOFTWARE: YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C     IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C     THE FREE SOFTWARE FOUNDATION, EITHER VERSION 3 OF THE LICENSE, OR (AT
C      YOUR OPTION) ANY LATER VERSION.

C     THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C     WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C     MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C     GENERAL PUBLIC LICENSE FOR MORE DETAILS.

C     YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C     ALONG WITH THIS PROGRAM. IF NOT, SEE HTTP://WWW.GNU.ORG/LICENSES/.

C     THIS SUBROUTINE IMPLEMENTS DEVELOPMENTAL PAUSES AND LIFE CYCLE RESETS AFTER METAMORPHOSIS

      IMPLICIT NONE

      INTEGER AQUABREED1,AQUASTAGE1,BREEDING1,COMPLETE1,COMPLETION1
      INTEGER DEAD1,HOUR1,RESET1,STAGES1,WAITING1
      DOUBLE PRECISION CONTDEP1,E_HB1,E_H_PRES1,STAGE1

      WAITING1=0

      IF(RESET1.GT.0)THEN
       IF(STAGE1.GE.RESET1)THEN
        COMPLETE1=1
        STAGE1=STAGES1-1
       ENDIF
      ENDIF

      IF((COMPLETE1.EQ.1).AND.(HOUR1.EQ.24))THEN
       COMPLETION1=COMPLETION1+1
       DEAD1=1
       COMPLETE1=0
       STAGE1=STAGES1-1
      ENDIF

      IF(AQUABREED1.EQ.1)THEN
       IF(BREEDING1.EQ.1)THEN
        IF(AQUASTAGE1.EQ.1)THEN
C        RESETTING AT METAMORPHOSIS
         IF(STAGE1.EQ.2)THEN
          DEAD1=1
         ENDIF
        ENDIF
       ENDIF
      ENDIF

      IF(AQUABREED1.EQ.1)THEN
       IF(STAGE1.LE.1)THEN
         IF(CONTDEP1.LE.0.1)THEN
          DEAD1=1
         ENDIF
       ENDIF
      ENDIF

C     PREVENT EGG DEVELOPMENT IN SOIL IF NOT THE RIGHT SEASON
      IF(AQUABREED1.EQ.2)THEN
       IF(E_H_PRES1.LT.E_HB1)THEN
        IF(BREEDING1.EQ.0)THEN
         DEAD1=1
        ENDIF
       ENDIF
      ENDIF

C     KILL EGGS OF TERRESTRIAL BREEDERS IF THE POND FILLS UP TOO SOON
C     IF(AQUABREED1.EQ.2)THEN
C      IF(STAGE1.EQ.0)THEN
C       IF(E_H_PRES1.LT.E_HB1*0.90)THEN
C       IF(CONTDEP1.GT.50)THEN
C        DEAD1=1
C       ENDIF
C      ENDIF
C      ENDIF
C     ENDIF

C     KILL TADPOLES IF POND DRIES
      IF(AQUABREED1.EQ.2)THEN
       IF(STAGE1.EQ.1)THEN
        IF(CONTDEP1.LE.0.1)THEN
         WAITING1=1
         E_H_PRES1=E_HB1
         STAGE1=0
        ENDIF
       ENDIF
       IF(AQUASTAGE1.EQ.1)THEN
        IF(STAGE1.EQ.2)THEN
         DEAD1=1
         WAITING1=0
        ENDIF
       ENDIF
      ENDIF

      IF(AQUABREED1.EQ.2)THEN
       IF(STAGE1.EQ.1)THEN
         IF(CONTDEP1.LE.0.1)THEN
          DEAD1=1
          WAITING1=0
        ENDIF
       ENDIF
      ENDIF

      IF(AQUABREED1.EQ.3)THEN
       IF(AQUASTAGE1.EQ.1)THEN
        IF(BREEDING1.EQ.1)THEN
         IF(STAGE1.GE.1)THEN
          DEAD1=1
          WAITING1=0
         ENDIF
        ELSE
         DEAD1=1
         WAITING1=0
        ENDIF
       ENDIF
      ENDIF

      IF(AQUABREED1.EQ.3)THEN
       IF(AQUASTAGE1.EQ.0)THEN
        IF(E_H_PRES1.LT.E_HB1)THEN
         IF(BREEDING1.EQ.0)THEN
          DEAD1=1
          WAITING1=0
         ENDIF
        ENDIF
       ENDIF
      ENDIF

      RETURN
      END