      SUBROUTINE ZBRAC(FUN,X1,X2,SUCCES)
      DOUBLE PRECISION FACTOR,X1,X2,F1,FUN,F2
      INTEGER J,NTRY

C     NICHEMAPR: SOFTWARE FOR BIOPHYSICAL MECHANISTIC NICHE MODELLING

C     COPYRIGHT (C) 2018 MICHAEL R. KEARNEY AND WARREN P. PORTER

C     THIS PROGRAM IS FREE SOFTWARE: YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C     IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C     THE FREE SOFTWARE FOUNDATION, EITHER VERSION 3 OF THE LICENSE, OR (AT
C      YOUR OPTION) ANY LATER VERSION.

C     THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C     WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C     MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C     GENERAL PUBLIC LICENSE FOR MORE DETAILS.

C     YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C     ALONG WITH THIS PROGRAM. IF NOT, SEE HTTP://WWW.GNU.ORG/LICENSES/.

C     FINDS BRACKETING VALUES FOR ZBRENT
C     TAKEN FROM
C     RICHARD BRENT,
C     ALGORITHMS FOR MINIMIZATION WITHOUT DERIVATIVES,
C     DOVER, 2002,
C     ISBN: 0-486-41998-3,
C     LC: QA402.5.B74.

      LOGICAL SUCCES
      FACTOR=1.6
      NTRY=50
C     IF(X1.EQ.X2)PAUSE 'YOU HAVE TO GUESS AN INITIAL RANGE'
      F1=FUN(X1)
      F2=FUN(X2)
      SUCCES=.TRUE.
      DO 11 J=1,NTRY
       IF(F1*F2.LT.0.)RETURN
       IF(ABS(F1).LT.ABS(F2))THEN
        X1=X1+FACTOR*(X1-X2)
        F1=FUN(X1)
       ELSE
        X2=X2+FACTOR*(X2-X1)
        F2=FUN(X2)
       ENDIF
11    CONTINUE
      SUCCES=.FALSE.
      RETURN
      END